import { ERC1155, ERC20, ERC721, WalletRegistry } from '../types/abis';
declare type ContractType = 'ERC20' | 'ERC721' | 'ERC1155' | 'WalletRegistry';
/**
 * Class representing a contract instance
 */
export declare class ContractInstance {
    /**
     * Create a contract instance.
     * @param contractType - type of the contract
     * @param address -the address of the contract for which the instance needs to be created
     * @return contract instance
     */
    protected getContractInstance: (contractType: ContractType, address: string) => Promise<ERC1155 | ERC20 | ERC721 | WalletRegistry>;
}
export {};
