"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractInstance = void 0;
var tslib_1 = require("tslib");
var ethers_1 = require("../utils/ethers");
var config_1 = require("../config");
var getSigner_1 = tslib_1.__importDefault(require("./utils/getSigner"));
/**
 * Class representing a contract instance
 */
var ContractInstance = /** @class */ (function () {
    function ContractInstance() {
        var _this = this;
        /**
         * Create a contract instance.
         * @param contractType - type of the contract
         * @param address -the address of the contract for which the instance needs to be created
         * @return contract instance
         */
        this.getContractInstance = function (contractType, address) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var pvt_key, RPC, signer;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pvt_key = config_1.key.getPrivateKey();
                        RPC = config_1.key.getRPC();
                        return [4 /*yield*/, (0, getSigner_1.default)(pvt_key, RPC)];
                    case 1:
                        signer = _a.sent();
                        return [2 /*return*/, (0, ethers_1.getContract)(signer, contractType, address)];
                }
            });
        }); };
    }
    return ContractInstance;
}());
exports.ContractInstance = ContractInstance;
//# sourceMappingURL=index.js.map