"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var ethers_1 = tslib_1.__importStar(require("../../utils/ethers"));
/**
 * get the signer
 * ___________________________________________
 * @param pvt_key - private key of the signer
 * @param RPC - rpc string
 * @returns signer instance
 * @example
 * const contract = await getSigner(pvt_key, RPC)
 */
function getSigner(pvt_ky, RPC) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var provider;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, ethers_1.default)(RPC)];
                case 1:
                    provider = _a.sent();
                    return [4 /*yield*/, (0, ethers_1.setupSigner)(pvt_ky, provider)];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.default = getSigner;
//# sourceMappingURL=getSigner.js.map