"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var __1 = require("..");
describe('Nft service test cases', function () {
    var nftService = null;
    var address = '0x065A2d67FadD725626F4E689c3aceFF7511BEfd0';
    it('Should create Nft service instance', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            try {
                nftService = new __1.NftService();
                expect(nftService).toBeTruthy();
            }
            catch (error) {
                console.log(Error);
            }
            return [2 /*return*/];
        });
    }); });
    it('getAccountHistory', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var accountHistory, error_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getAccountHistory(address)];
                case 1:
                    accountHistory = _a.sent();
                    console.log(accountHistory.data.length);
                    expect(accountHistory.data.length).toBeGreaterThan(0);
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getAccountTransactions', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var accountTransactions, error_2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getAccountTransactions(address)];
                case 1:
                    accountTransactions = _a.sent();
                    console.log(accountTransactions.message);
                    expect(accountTransactions.message).toBe('Collection of nft owned by the wallet address');
                    return [3 /*break*/, 3];
                case 2:
                    error_2 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getNftDetails #No Token Address', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var nftDetails, error_3;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getNftDetails(address)];
                case 1:
                    nftDetails = _a.sent();
                    console.log(nftDetails.message);
                    expect(nftDetails.message).toBe('Collection of nft owned by the wallet address');
                    return [3 /*break*/, 3];
                case 2:
                    error_3 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getNftDetails', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var nftDetails, error_4;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getNftDetails(address, '0x893ed2D55A1231BFAfd125291fd8cc0a2fB28E01')];
                case 1:
                    nftDetails = _a.sent();
                    console.log(nftDetails.message);
                    expect(nftDetails.message).toBe('Collection of nft owned by the wallet address');
                    return [3 /*break*/, 3];
                case 2:
                    error_4 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getTokenBalance', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var tokenBal, error_5;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getTokenBalance(address)];
                case 1:
                    tokenBal = _a.sent();
                    expect(tokenBal).toBeTruthy();
                    return [3 /*break*/, 3];
                case 2:
                    error_5 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('resyncMetadataOfNft', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var syncedMetadata, error_6;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.resyncMetadataOfNft(address, '0x11')];
                case 1:
                    syncedMetadata = _a.sent();
                    console.log(syncedMetadata.message);
                    expect(syncedMetadata.message).toBe('Metadata Updated');
                    return [3 /*break*/, 3];
                case 2:
                    error_6 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getBlockContent', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var blockContent, error_7;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getBlockContent('1235491')];
                case 1:
                    blockContent = _a.sent();
                    console.log(blockContent.message);
                    expect(blockContent.message).toBe('Contents of block');
                    return [3 /*break*/, 3];
                case 2:
                    error_7 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getTransactionLogs', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var txnLogs, error_8;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getTransactionLogs(address)];
                case 1:
                    txnLogs = _a.sent();
                    console.log(txnLogs.message);
                    expect(txnLogs.message).toBe('Address logs');
                    return [3 /*break*/, 3];
                case 2:
                    error_8 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getTransactionDetails', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var txnDetails, error_9;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getTransactionDetails('0x09b2820cb57f4a829c55a1a5b13e95e476cbd78ea6fae783f1f090aebe418f24')];
                case 1:
                    txnDetails = _a.sent();
                    console.log(txnDetails.message);
                    expect(txnDetails.message).toBe('Transaction details');
                    return [3 /*break*/, 3];
                case 2:
                    error_9 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    // eslint-disable-next-line jest/expect-expect
    it('getMetadata', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var metadata, error_10;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getMetadata('0x065A2d67FadD725626F4E689c3aceFF7511BEfd0,0x020837223c6dEA454D3a5E8006657F9F719cB08f')];
                case 1:
                    metadata = _a.sent();
                    console.log(metadata);
                    return [3 /*break*/, 3];
                case 2:
                    error_10 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getErc20TokenTransfers #No To & From', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var metadata, error_11;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getErc20TokenTransfers(address)];
                case 1:
                    metadata = _a.sent();
                    console.log(metadata);
                    expect(metadata.message).toBe('ERC20 token transactions in descending order');
                    return [3 /*break*/, 3];
                case 2:
                    error_11 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('getErc20TokenTransfers', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var metadata, error_12;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, nftService.getErc20TokenTransfers(address, '1063', '1015')];
                case 1:
                    metadata = _a.sent();
                    console.log(metadata);
                    expect(metadata.message).toBe('ERC20 token transactions in descending order');
                    return [3 /*break*/, 3];
                case 2:
                    error_12 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=nftservice.spec.js.map