import { IBlock, ITransaction, ITransactions, ITransactionsER20, ITransactionsNFT } from './type';
export declare class NftService {
    getAccountHistory: (address: string) => Promise<ITransactions>;
    getNftDetails: (address: string, token_address?: string) => Promise<ITransactionsNFT>;
    getAccountTransactions: (address: string) => Promise<ITransactionsNFT>;
    getTokenBalance: (address: string) => Promise<string>;
    getErc20TokenTransfers: (address: string, to_block: string, from_block: string) => Promise<ITransactionsER20>;
    getBlockContent: (block_info: string) => Promise<IBlock>;
    getTransactionLogs: (address: string) => Promise<ITransactions>;
    getTransactionDetails: (transactionHash: string) => Promise<ITransaction>;
    getContractLevelMetadata: (address: string) => Promise<string[]>;
    resyncMetadataOfNft: (address: string, token_id: string) => Promise<ITransaction>;
    getMetadata: (value: string) => Promise<{
        address: string;
        name: string;
        symbol: string;
    }[]>;
}
