"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var erc20_1 = require("../erc20");
var main_1 = require("../../main");
describe('ERC20 interactions', function () {
    var erc20 = null, erc20Instance = null;
    beforeAll(function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var sdk;
        return tslib_1.__generator(this, function (_a) {
            try {
                sdk = new main_1.ElysiumSDK();
                sdk.init({
                    privateKey: '8284a1896d0924582038749a5a5f35a663791a6051adb5ff205df8dfebeaa705',
                });
                // erc20 = new ERC20();
                // erc20Instance = await erc20.init(
                //     '0xa88B4c42B9e4A111cefCe3A8C62F5DbdaB54fAAC',
                // );
            }
            catch (error) {
                console.log(error);
            }
            return [2 /*return*/];
        });
    }); });
    it('should create erc20 instance', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var error_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    erc20 = new erc20_1.ERC20();
                    return [4 /*yield*/, erc20.init('0xa88B4c42B9e4A111cefCe3A8C62F5DbdaB54fAAC')];
                case 1:
                    erc20Instance = _a.sent();
                    expect(erc20Instance).toBeTruthy();
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    console.log(Error);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('instance address should be equal to the parameters address', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        return tslib_1.__generator(this, function (_a) {
            try {
                expect(erc20Instance.address).toBe('0xa88B4c42B9e4A111cefCe3A8C62F5DbdaB54fAAC');
            }
            catch (error) {
                console.log(error);
            }
            return [2 /*return*/];
        });
    }); });
    it('should have a correct name', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var name, error_2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, erc20Instance.name()];
                case 1:
                    name = _a.sent();
                    expect(name).toBe('ElysiumTest');
                    return [3 /*break*/, 3];
                case 2:
                    error_2 = _a.sent();
                    console.log(error_2);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('should have a correct symbol', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var name, error_3;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, erc20Instance.symbol()];
                case 1:
                    name = _a.sent();
                    expect(name).toBe('ELY');
                    return [3 /*break*/, 3];
                case 2:
                    error_3 = _a.sent();
                    console.log(error_3);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('should have a correct total supply', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var totalSupply, error_4;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, erc20Instance.totalSupply()];
                case 1:
                    totalSupply = _a.sent();
                    expect(BigInt(totalSupply)).toBe(BigInt('0xd3c21bcecceda1000000')); // decimal value 1000000000000000000000000
                    return [3 /*break*/, 3];
                case 2:
                    error_4 = _a.sent();
                    console.log(error_4);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    }); });
    it('beneficiary should have less than the total supply', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var totalSupply, beneficiaryBalance;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, erc20Instance.totalSupply()];
                case 1:
                    totalSupply = _a.sent();
                    return [4 /*yield*/, erc20Instance.balanceOf('0x6f902Af1740464668649e467EF6d1F84EE598eC8')];
                case 2:
                    beneficiaryBalance = _a.sent();
                    expect(BigInt(beneficiaryBalance)).toBeLessThan(BigInt(totalSupply));
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=erc20.spec.js.map