import type { BaseContract, BigNumber, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "./common";
export interface WalletRegistryInterface extends utils.Interface {
    functions: {
        "alreadyVotedToUpdateOwner(address,address)": FunctionFragment;
        "alreadyVotedToUpdateProxy(address,address)": FunctionFragment;
        "deployWallet(address)": FunctionFragment;
        "disableLogic(address)": FunctionFragment;
        "enableLogic(address)": FunctionFragment;
        "enableLogicMultiple(address[])": FunctionFragment;
        "forwardProxy()": FunctionFragment;
        "logic(address)": FunctionFragment;
        "logicProxies(address)": FunctionFragment;
        "manager()": FunctionFragment;
        "maxOwners()": FunctionFragment;
        "minVotesNeeded()": FunctionFragment;
        "ownerByAddress(address)": FunctionFragment;
        "ownersCount()": FunctionFragment;
        "setOwners(address[])": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "updateOwner(address,address)": FunctionFragment;
        "updateProxy(address)": FunctionFragment;
        "voteToRemoveOwner(address)": FunctionFragment;
        "voteToUpdateProxy(address)": FunctionFragment;
        "votesToUpdateOwner(address)": FunctionFragment;
        "votesToUpdateProxy(address)": FunctionFragment;
        "walletRegistered(address)": FunctionFragment;
        "wallets(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "alreadyVotedToUpdateOwner" | "alreadyVotedToUpdateProxy" | "deployWallet" | "disableLogic" | "enableLogic" | "enableLogicMultiple" | "forwardProxy" | "logic" | "logicProxies" | "manager" | "maxOwners" | "minVotesNeeded" | "ownerByAddress" | "ownersCount" | "setOwners" | "transferOwnership" | "updateOwner" | "updateProxy" | "voteToRemoveOwner" | "voteToUpdateProxy" | "votesToUpdateOwner" | "votesToUpdateProxy" | "walletRegistered" | "wallets"): FunctionFragment;
    encodeFunctionData(functionFragment: "alreadyVotedToUpdateOwner", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "alreadyVotedToUpdateProxy", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "deployWallet", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "disableLogic", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "enableLogic", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "enableLogicMultiple", values: [PromiseOrValue<string>[]]): string;
    encodeFunctionData(functionFragment: "forwardProxy", values?: undefined): string;
    encodeFunctionData(functionFragment: "logic", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "logicProxies", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "manager", values?: undefined): string;
    encodeFunctionData(functionFragment: "maxOwners", values?: undefined): string;
    encodeFunctionData(functionFragment: "minVotesNeeded", values?: undefined): string;
    encodeFunctionData(functionFragment: "ownerByAddress", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "ownersCount", values?: undefined): string;
    encodeFunctionData(functionFragment: "setOwners", values: [PromiseOrValue<string>[]]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "updateOwner", values: [PromiseOrValue<string>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "updateProxy", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "voteToRemoveOwner", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "voteToUpdateProxy", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "votesToUpdateOwner", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "votesToUpdateProxy", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "walletRegistered", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "wallets", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "alreadyVotedToUpdateOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "alreadyVotedToUpdateProxy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deployWallet", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "disableLogic", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "enableLogic", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "enableLogicMultiple", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "forwardProxy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "logic", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "logicProxies", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "manager", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxOwners", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "minVotesNeeded", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "ownerByAddress", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "ownersCount", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setOwners", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateProxy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "voteToRemoveOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "voteToUpdateProxy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "votesToUpdateOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "votesToUpdateProxy", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "walletRegistered", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "wallets", data: BytesLike): Result;
    events: {
        "Created(address,address)": EventFragment;
        "LogDisableLogic(address)": EventFragment;
        "LogEnableLogic(address)": EventFragment;
        "NewProxy(address)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "SetOwners(address[])": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Created"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogDisableLogic"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "LogEnableLogic"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "NewProxy"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetOwners"): EventFragment;
}
export interface CreatedEventObject {
    owner: string;
    proxy: string;
}
export declare type CreatedEvent = TypedEvent<[string, string], CreatedEventObject>;
export declare type CreatedEventFilter = TypedEventFilter<CreatedEvent>;
export interface LogDisableLogicEventObject {
    logicAddress: string;
}
export declare type LogDisableLogicEvent = TypedEvent<[
    string
], LogDisableLogicEventObject>;
export declare type LogDisableLogicEventFilter = TypedEventFilter<LogDisableLogicEvent>;
export interface LogEnableLogicEventObject {
    logicAddress: string;
}
export declare type LogEnableLogicEvent = TypedEvent<[
    string
], LogEnableLogicEventObject>;
export declare type LogEnableLogicEventFilter = TypedEventFilter<LogEnableLogicEvent>;
export interface NewProxyEventObject {
    proxy: string;
}
export declare type NewProxyEvent = TypedEvent<[string], NewProxyEventObject>;
export declare type NewProxyEventFilter = TypedEventFilter<NewProxyEvent>;
export interface OwnershipTransferredEventObject {
    previousOwner: string;
    newOwner: string;
}
export declare type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], OwnershipTransferredEventObject>;
export declare type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export interface SetOwnersEventObject {
    owners: string[];
}
export declare type SetOwnersEvent = TypedEvent<[string[]], SetOwnersEventObject>;
export declare type SetOwnersEventFilter = TypedEventFilter<SetOwnersEvent>;
export interface WalletRegistry extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: WalletRegistryInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        alreadyVotedToUpdateOwner(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        alreadyVotedToUpdateProxy(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        /**
         * Deploys a new proxy instance and sets custom owner of proxy Throws if the owner already have a UserWallet
         */
        deployWallet(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Disable logic proxy address
         * @param _logicAddress (address)
         */
        disableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Enable logic proxy address
         * @param _logicAddress (address)
         */
        enableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Enable multiple logic proxy addresses
         * @param _logicAddresses (addresses)
         */
        enableLogicMultiple(_logicAddresses: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Address of forward proxy contract
         */
        forwardProxy(overrides?: CallOverrides): Promise<[string]>;
        /**
         * @param _logicAddress (address)
         */
        logic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        /**
         * Map of logic proxy state
         */
        logicProxies(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        manager(overrides?: CallOverrides): Promise<[string]>;
        maxOwners(overrides?: CallOverrides): Promise<[BigNumber]>;
        minVotesNeeded(overrides?: CallOverrides): Promise<[BigNumber]>;
        ownerByAddress(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        ownersCount(overrides?: CallOverrides): Promise<[BigNumber]>;
        /**
         * Function to set owners addresses
         */
        setOwners(_owners: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.
         */
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Removes owner if the minimum voting count is reached and transfers ownership of the contract to a new account (`_newOwner`). Can only be called by the current owners except for the owner that has to be removed.
         */
        updateOwner(_owner: PromiseOrValue<string>, _newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Updates forward proxy
         * @param _newProxy (address) Throws if the sender is not owner
         */
        updateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Calcultes votes to remove an owner. Can only be called by the current owners.
         */
        voteToRemoveOwner(_owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        /**
         * Calcultes votes to update proxy.
         * @param _newProxy (address)
         */
        voteToUpdateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        votesToUpdateOwner(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        votesToUpdateProxy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[BigNumber]>;
        /**
         * Address to Bool registration status map
         */
        walletRegistered(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        /**
         * Address to UserWallet proxy map
         */
        wallets(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[string]>;
    };
    alreadyVotedToUpdateOwner(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    alreadyVotedToUpdateProxy(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    /**
     * Deploys a new proxy instance and sets custom owner of proxy Throws if the owner already have a UserWallet
     */
    deployWallet(user: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Disable logic proxy address
     * @param _logicAddress (address)
     */
    disableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Enable logic proxy address
     * @param _logicAddress (address)
     */
    enableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Enable multiple logic proxy addresses
     * @param _logicAddresses (addresses)
     */
    enableLogicMultiple(_logicAddresses: PromiseOrValue<string>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Address of forward proxy contract
     */
    forwardProxy(overrides?: CallOverrides): Promise<string>;
    /**
     * @param _logicAddress (address)
     */
    logic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    /**
     * Map of logic proxy state
     */
    logicProxies(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    manager(overrides?: CallOverrides): Promise<string>;
    maxOwners(overrides?: CallOverrides): Promise<BigNumber>;
    minVotesNeeded(overrides?: CallOverrides): Promise<BigNumber>;
    ownerByAddress(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    ownersCount(overrides?: CallOverrides): Promise<BigNumber>;
    /**
     * Function to set owners addresses
     */
    setOwners(_owners: PromiseOrValue<string>[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.
     */
    transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Removes owner if the minimum voting count is reached and transfers ownership of the contract to a new account (`_newOwner`). Can only be called by the current owners except for the owner that has to be removed.
     */
    updateOwner(_owner: PromiseOrValue<string>, _newOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Updates forward proxy
     * @param _newProxy (address) Throws if the sender is not owner
     */
    updateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Calcultes votes to remove an owner. Can only be called by the current owners.
     */
    voteToRemoveOwner(_owner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    /**
     * Calcultes votes to update proxy.
     * @param _newProxy (address)
     */
    voteToUpdateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    votesToUpdateOwner(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    votesToUpdateProxy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    /**
     * Address to Bool registration status map
     */
    walletRegistered(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    /**
     * Address to UserWallet proxy map
     */
    wallets(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
    callStatic: {
        alreadyVotedToUpdateOwner(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        alreadyVotedToUpdateProxy(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        /**
         * Deploys a new proxy instance and sets custom owner of proxy Throws if the owner already have a UserWallet
         */
        deployWallet(user: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
        /**
         * Disable logic proxy address
         * @param _logicAddress (address)
         */
        disableLogic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Enable logic proxy address
         * @param _logicAddress (address)
         */
        enableLogic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Enable multiple logic proxy addresses
         * @param _logicAddresses (addresses)
         */
        enableLogicMultiple(_logicAddresses: PromiseOrValue<string>[], overrides?: CallOverrides): Promise<void>;
        /**
         * Address of forward proxy contract
         */
        forwardProxy(overrides?: CallOverrides): Promise<string>;
        /**
         * @param _logicAddress (address)
         */
        logic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        /**
         * Map of logic proxy state
         */
        logicProxies(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        manager(overrides?: CallOverrides): Promise<string>;
        maxOwners(overrides?: CallOverrides): Promise<BigNumber>;
        minVotesNeeded(overrides?: CallOverrides): Promise<BigNumber>;
        ownerByAddress(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        ownersCount(overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Function to set owners addresses
         */
        setOwners(_owners: PromiseOrValue<string>[], overrides?: CallOverrides): Promise<void>;
        /**
         * Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.
         */
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Removes owner if the minimum voting count is reached and transfers ownership of the contract to a new account (`_newOwner`). Can only be called by the current owners except for the owner that has to be removed.
         */
        updateOwner(_owner: PromiseOrValue<string>, _newOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Updates forward proxy
         * @param _newProxy (address) Throws if the sender is not owner
         */
        updateProxy(_newProxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Calcultes votes to remove an owner. Can only be called by the current owners.
         */
        voteToRemoveOwner(_owner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        /**
         * Calcultes votes to update proxy.
         * @param _newProxy (address)
         */
        voteToUpdateProxy(_newProxy: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        votesToUpdateOwner(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        votesToUpdateProxy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Address to Bool registration status map
         */
        walletRegistered(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        /**
         * Address to UserWallet proxy map
         */
        wallets(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "Created(address,address)"(owner?: PromiseOrValue<string> | null, proxy?: null): CreatedEventFilter;
        Created(owner?: PromiseOrValue<string> | null, proxy?: null): CreatedEventFilter;
        "LogDisableLogic(address)"(logicAddress?: PromiseOrValue<string> | null): LogDisableLogicEventFilter;
        LogDisableLogic(logicAddress?: PromiseOrValue<string> | null): LogDisableLogicEventFilter;
        "LogEnableLogic(address)"(logicAddress?: PromiseOrValue<string> | null): LogEnableLogicEventFilter;
        LogEnableLogic(logicAddress?: PromiseOrValue<string> | null): LogEnableLogicEventFilter;
        "NewProxy(address)"(proxy?: PromiseOrValue<string> | null): NewProxyEventFilter;
        NewProxy(proxy?: PromiseOrValue<string> | null): NewProxyEventFilter;
        "OwnershipTransferred(address,address)"(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
        OwnershipTransferred(previousOwner?: PromiseOrValue<string> | null, newOwner?: PromiseOrValue<string> | null): OwnershipTransferredEventFilter;
        "SetOwners(address[])"(owners?: null): SetOwnersEventFilter;
        SetOwners(owners?: null): SetOwnersEventFilter;
    };
    estimateGas: {
        alreadyVotedToUpdateOwner(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        alreadyVotedToUpdateProxy(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Deploys a new proxy instance and sets custom owner of proxy Throws if the owner already have a UserWallet
         */
        deployWallet(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Disable logic proxy address
         * @param _logicAddress (address)
         */
        disableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Enable logic proxy address
         * @param _logicAddress (address)
         */
        enableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Enable multiple logic proxy addresses
         * @param _logicAddresses (addresses)
         */
        enableLogicMultiple(_logicAddresses: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Address of forward proxy contract
         */
        forwardProxy(overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * @param _logicAddress (address)
         */
        logic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Map of logic proxy state
         */
        logicProxies(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        manager(overrides?: CallOverrides): Promise<BigNumber>;
        maxOwners(overrides?: CallOverrides): Promise<BigNumber>;
        minVotesNeeded(overrides?: CallOverrides): Promise<BigNumber>;
        ownerByAddress(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        ownersCount(overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Function to set owners addresses
         */
        setOwners(_owners: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.
         */
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Removes owner if the minimum voting count is reached and transfers ownership of the contract to a new account (`_newOwner`). Can only be called by the current owners except for the owner that has to be removed.
         */
        updateOwner(_owner: PromiseOrValue<string>, _newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Updates forward proxy
         * @param _newProxy (address) Throws if the sender is not owner
         */
        updateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Calcultes votes to remove an owner. Can only be called by the current owners.
         */
        voteToRemoveOwner(_owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        /**
         * Calcultes votes to update proxy.
         * @param _newProxy (address)
         */
        voteToUpdateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        votesToUpdateOwner(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        votesToUpdateProxy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Address to Bool registration status map
         */
        walletRegistered(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        /**
         * Address to UserWallet proxy map
         */
        wallets(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        alreadyVotedToUpdateOwner(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        alreadyVotedToUpdateProxy(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * Deploys a new proxy instance and sets custom owner of proxy Throws if the owner already have a UserWallet
         */
        deployWallet(user: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Disable logic proxy address
         * @param _logicAddress (address)
         */
        disableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Enable logic proxy address
         * @param _logicAddress (address)
         */
        enableLogic(_logicAddress: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Enable multiple logic proxy addresses
         * @param _logicAddresses (addresses)
         */
        enableLogicMultiple(_logicAddresses: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Address of forward proxy contract
         */
        forwardProxy(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * @param _logicAddress (address)
         */
        logic(_logicAddress: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * Map of logic proxy state
         */
        logicProxies(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        manager(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxOwners(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        minVotesNeeded(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        ownerByAddress(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        ownersCount(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * Function to set owners addresses
         */
        setOwners(_owners: PromiseOrValue<string>[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Transfers ownership of the contract to a new account (`newOwner`). Can only be called by the current owner.
         */
        transferOwnership(newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Removes owner if the minimum voting count is reached and transfers ownership of the contract to a new account (`_newOwner`). Can only be called by the current owners except for the owner that has to be removed.
         */
        updateOwner(_owner: PromiseOrValue<string>, _newOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Updates forward proxy
         * @param _newProxy (address) Throws if the sender is not owner
         */
        updateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Calcultes votes to remove an owner. Can only be called by the current owners.
         */
        voteToRemoveOwner(_owner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        /**
         * Calcultes votes to update proxy.
         * @param _newProxy (address)
         */
        voteToUpdateProxy(_newProxy: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        votesToUpdateOwner(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        votesToUpdateProxy(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * Address to Bool registration status map
         */
        walletRegistered(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        /**
         * Address to UserWallet proxy map
         */
        wallets(arg0: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
