"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var index_1 = require("../index");
var main_1 = require("../../main");
var ethers_1 = require("ethers");
describe('Create wallet', function () {
    var walletService;
    var wallet;
    beforeEach(function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var sdk, result;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sdk = new main_1.ElysiumSDK();
                    sdk.init({
                        privateKey: '1934c4fa3a8c7130c55b4b2933657b584102c02e6fdc682394728822a714404e',
                    });
                    walletService = new index_1.WalletService();
                    return [4 /*yield*/, walletService.createWallet()];
                case 1:
                    result = _a.sent();
                    wallet = result.wallet;
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return unique wallet every time', function () { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var wallet2;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, walletService.createWallet()];
                case 1:
                    wallet2 = _a.sent();
                    expect(wallet2).not.toEqual(wallet);
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return a wallet with address of length 42', function () {
        expect(wallet).toHaveLength(42);
    });
    it('should be a valid evm address', function () {
        expect(ethers_1.ethers.utils.isAddress(wallet)).toBe(true);
    });
    // eslint-disable-next-line jest/no-commented-out-tests
    // it('should be able to import a wallet', async () => {
    //     const { address, privateKey } = ethers.Wallet.createRandom();
    //     const {address as ad, privateKey as pk} = await walletService.createWallet({
    //         address,
    //         privateKey,
    //     });
    //     expect(wallet).toHaveLength(42);
    //     expect(typeof wallet).toBe('string');
    // });
    // TODO: handle errors from contract with jest
    // eslint-disable-next-line jest/no-commented-out-tests
    // it('should throw error when creating wallet mutiple times with same user address', async () => {
    //
    //     const wallet = await walletService.createWallet({
    //         address: '0x94f3178AcB40d0E9c6967108e3711CF047D3240A',
    //         privateKey: '1934c4fa3a8c7130c55b4b2933657b584102c02e6fdc682394728822a714404e'
    //     })
    //
    //     expect(wallet).toThrow(''); -> TODO: handle error
    // });
});
//# sourceMappingURL=create.spec.js.map