"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WalletService = void 0;
var tslib_1 = require("tslib");
/**
 * creates a new wallet and returns the wallet address.
 */
var ethers_1 = require("ethers");
var contracts_1 = require("../contracts");
var WalletService = /** @class */ (function (_super) {
    tslib_1.__extends(WalletService, _super);
    function WalletService() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getWalletRegistry = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getContractInstance('WalletRegistry', '0xf60F6Bf9210454a15dD41284668E2B7868faA486')];
                    case 1: return [2 /*return*/, (_a.sent())];
                }
            });
        }); };
        _this.getWallet = function (address) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var walletRegistry;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getWalletRegistry()];
                    case 1:
                        walletRegistry = _a.sent();
                        return [4 /*yield*/, walletRegistry.wallets(address)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        }); };
        _this.createWallet = function (existingWallet) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var walletRegistry, _a, address, privateKey, gas, smartWallet, wallet;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getWalletRegistry()];
                    case 1:
                        walletRegistry = _b.sent();
                        _a = existingWallet || ethers_1.ethers.Wallet.createRandom(), address = _a.address, privateKey = _a.privateKey;
                        return [4 /*yield*/, walletRegistry.estimateGas.deployWallet(address)];
                    case 2:
                        gas = _b.sent();
                        return [4 /*yield*/, walletRegistry.deployWallet(address, {
                                gasLimit: gas,
                            })];
                    case 3:
                        smartWallet = _b.sent();
                        return [4 /*yield*/, smartWallet.wait()];
                    case 4:
                        _b.sent();
                        return [4 /*yield*/, this.getWallet(address)];
                    case 5:
                        wallet = _b.sent();
                        return [2 /*return*/, { wallet: wallet, privateKey: privateKey }];
                }
            });
        }); };
        return _this;
    }
    return WalletService;
}(contracts_1.ContractInstance));
exports.WalletService = WalletService;
//# sourceMappingURL=index.js.map